%define ocamlname socketcan

Name:           ocaml-%{ocamlname}
Version:        0.8.12
Release:        1%{?dist}.emp1
Summary:        OCaml bindings to the Linux SocketCAN interface
License:        MIT
URL:            https://github.com/mwweissmann/ocaml-socketcan
Source0:        %{name}-%{version}.tar.gz

Requires:       ocaml
Requires:       ocaml-result
Requires:       ocaml-posix-time >= 1.0.0

BuildRequires:  ocaml
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-oasis
BuildRequires:  ocaml-result-devel
BuildRequires:  ocaml-posix-time-devel >= 1.0.0
BuildRequires:  ocaml-findlib >= 1.5
BuildRequires:  kernel-headers

%description 
This OCaml library provides bindings to the Linux SocketCAN interface.
API: http://mwweissmann.github.io/ocaml-socketcan/

Linux SocketCAN:
https://www.kernel.org/doc/Documentation/networking/can.txt

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-result-devel
Requires:       ocaml-posix-time-devel >= 1.0.0

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{name}-%{version}
oasis setup-clean
oasis setup
ocaml setup.ml -configure --prefix %{_prefix} \
      --libdir %{_libdir} \
      --libexecdir %{_libexecdir} \
      --exec-prefix %{_exec_prefix} \
      --bindir %{_bindir} \
      --sbindir %{_sbindir} \
      --mandir %{_mandir} \
      --datadir %{_datadir} \
      --localstatedir %{_localstatedir} \
      --sharedstatedir %{_sharedstatedir} \
      --destdir $RPM_BUILD_ROOT

%build
ocaml setup.ml -build

%install
export DESTDIR=$RPM_BUILD_ROOT
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/ocaml/stublibs
ocaml setup.ml -install 

%files
%doc LICENSE
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner

%files devel
%doc README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
